## cwirc 1.8.8

=== Makefile ===
##### PLEASE SET THE FOLLOWING VARIABLES FIRST ################################
# - Set TARGET_OS to LINUX, FREEBSD or NETBSD.
#
# - PLUGIN_INSTALL_DIRECTORY is where the CWirc plugin stub (cwirc.so) is
#   installed. It should be the X-Chat plugins directory, so the CWirc
#   plugin is loaded automatically when X-Chat starts.
#
# - FRONTEND_INSTALL_DIRECTORY is where the CWirc frontend executable is
#   installed. It should be a bin directory in the PATH, so the plugin
#   portion can execute it.
#
# - CWIRC_EXTENSIONS_DIRECTORY is where CWirc will look for extension programs.
#
# - Define any additional linker flags your system might need in EXTRA_LDFLAGS
#   (for example, "-lossaudio" with NetBSD 1.6.1)
################################################################################

#TARGET_OS=
#PLUGIN_INSTALL_DIRECTORY=
#FRONTEND_INSTALL_DIRECTORY=
#CWIRC_EXTENSIONS_DIRECTORY=
#EXTRA_LDFLAGS=

# Use these with Debian GNU/Linux for example
#TARGET_OS=LINUX
#PLUGIN_INSTALL_DIRECTORY=/usr/lib/xchat/plugins
#FRONTEND_INSTALL_DIRECTORY=/usr/bin
#CWIRC_EXTENSIONS_DIRECTORY=/usr/lib/cwirc/extensions
#EXTRA_LDFLAGS=

# Use these with FreeBSD 5.1 for example
#TARGET_OS=FREEBSD
#PLUGIN_INSTALL_DIRECTORY=/usr/X11R6/lib/xchat/plugins
#FRONTEND_INSTALL_DIRECTORY=/usr/X11R6/bin
#CWIRC_EXTENSIONS_DIRECTORY=/usr/X11R6/lib/cwirc/extensions
#EXTRA_LDFLAGS=

# Use these with NetBSD 1.6.1 for example
#TARGET_OS=NETBSD
#PLUGIN_INSTALL_DIRECTORY=/usr/pkg/lib/xchat/plugins
#FRONTEND_INSTALL_DIRECTORY=/usr/pkg/bin
#CWIRC_EXTENSIONS_DIRECTORY=/usr/pkg/lib/cwirc/extensions
#EXTRA_LDFLAGS=-lossaudio

################################################################################

VERSION=1.8.8

PLUGIN=cwirc.so
FRONTEND=cwirc_frontend

RM=/bin/rm
CP=/bin/cp
MKDIR=/bin/mkdir
TAR=tar
PWD=pwd
CC=gcc
STRIP=strip

XCHAT_PLUGIN_INCLUDE_PATH=xchat

XCHAT_INC=-I$(XCHAT_PLUGIN_INCLUDE_PATH)
CFLAGS=-Wall -Wstrict-prototypes -O2 -D$(TARGET_OS)
GTK_CFLAGS=`pkg-config --cflags gtk+-2.0`
LDFLAGS=-lm ${EXTRA_LDFLAGS}
GTK_LDFLAGS=`pkg-config --libs gtk+-2.0`

all:			missing_settings				\
			$(PLUGIN) 					\
			$(FRONTEND)

install:		missing_settings				\
			$(PLUGIN)					\
			$(FRONTEND)
			$(MKDIR) -p $(PLUGIN_INSTALL_DIRECTORY)
			$(MKDIR) -p $(CWIRC_EXTENSIONS_DIRECTORY)
			$(CP) $(PLUGIN) $(PLUGIN_INSTALL_DIRECTORY)
			$(MKDIR) -p $(FRONTEND_INSTALL_DIRECTORY)
			$(CP) $(FRONTEND) $(FRONTEND_INSTALL_DIRECTORY)

uninstall:		missing_settings
			$(RM) -f $(PLUGIN_INSTALL_DIRECTORY)/$(PLUGIN)
			$(RM) -f $(FRONTEND_INSTALL_DIRECTORY)/$(FRONTEND)

PLUGIN_OBJS=		plugin.shared.o					\
			ipc.shared.o					\
			grid.shared.o					\
			propagation.shared.o				\
			cwframe.shared.o

FRONTEND_OBJS=		frontend.o					\
			io.o						\
			gui.o						\
			ipc.o						\
			keyer.o						\
			grid.o						\
			propagation.o					\
			cwsound.o					\
			cwdecoder.o					\
			cwframe.o					\
			rcfile.o					\
			extension.o

$(PLUGIN):		$(PLUGIN_OBJS)
			$(CC) -shared $(LDFLAGS) -o $@ $(PLUGIN_OBJS)
			$(STRIP) $@

$(FRONTEND):		$(FRONTEND_OBJS)
			$(CC) $(LDFLAGS) $(GTK_LDFLAGS) -o $@ $(FRONTEND_OBJS)
			$(STRIP) $@

plugin.shared.o:	plugin.c					\
			$(XCHAT_PLUGIN_INCLUDE_PATH)/xchat-plugin.h	\
			types.h						\
			common.h					\
			cwirc.h						\
			cwframe.h					\
			ipc.h
			$(CC) $(CFLAGS) $(XCHAT_INC) -fPIC -c -o $@ plugin.c

frontend.o:		frontend.c					\
			types.h						\
			cwirc.h						\
			common.h					\
			rcfile.h					\
			io.h						\
			gui.h						\
			extension.h					\
			ipc.h
			$(CC) $(CFLAGS) $(XCHAT_INC) -c -o $@ frontend.c

io.o:			io.c						\
			types.h						\
			io.h						\
			cwirc.h						\
			keyer.h						\
			cwsound.h					\
			cwdecoder.h					\
			propagation.h					\
			extension.h					\
			ipc.h
			$(CC) $(CFLAGS) -c -o $@ io.c

gui.o:			gui.c						\
			types.h						\
			gui.h						\
			common.h					\
			cwirc.h						\
			rcfile.h					\
			grid.h						\
			io.h						\
			cwdecoder.h					\
			extension.h					\
			keyer.h						\
			ipc.h						\
			smeter.xpm					\
			sidetone.xpm					\
			straightkey.xpm					\
			iambickey.xpm
			$(CC) $(CFLAGS) $(GTK_CFLAGS) -c -o $@ gui.c

keyer.o:		keyer.c						\
			types.h						\
			keyer.h
			$(CC) $(CFLAGS) -c -o $@ keyer.c

grid.o:			grid.c						\
			grid.h
			$(CC) $(CFLAGS) -c -o $@ grid.c

grid.shared.o:		grid.c						\
			grid.h
			$(CC) $(CFLAGS) -fPIC -c -o $@ grid.c

propagation.o:		propagation.c					\
			propagation.h
			$(CC) $(CFLAGS) -c -o $@ propagation.c

propagation.shared.o:	propagation.c					\
			propagation.h
			$(CC) $(CFLAGS) -fPIC -c -o $@ propagation.c

cwsound.o:		cwsound.c					\
			types.h						\
			cwsound.h					\
			sounder_down.h					\
			sounder_up.h
			$(CC) $(CFLAGS) -c -o $@ cwsound.c

cwframe.o:		cwframe.c					\
			types.h						\
			cwframe.h					\
			cwirc.h						\
			grid.h						\
			propagation.h					\
			io.h						\
			ipc.h
			$(CC) $(CFLAGS) -c -o $@ cwframe.c

cwframe.shared.o:	cwframe.c					\
			types.h						\
			cwframe.h					\
			cwirc.h						\
			grid.h						\
			propagation.h					\
			io.h						\
			ipc.h
			$(CC) $(CFLAGS) -fPIC -c -o $@ cwframe.c

cwdecoder.o:		cwdecoder.c					\
			types.h						\
			cwdecoder.h					\
			morsecodes.h					\
			cwirc.h
			$(CC) $(CFLAGS) -c -o $@ cwdecoder.c

ipc.o:			ipc.c						\
			ipc.h
			$(CC) $(CFLAGS) -c -o $@ ipc.c

ipc.shared.o:		ipc.c						\
			ipc.h
			$(CC) $(CFLAGS) -fPIC -c -o $@ ipc.c

rcfile.o:		rcfile.c					\
			types.h						\
			rcfile.h					\
			cwirc.h						\
			grid.h						\
			io.h						\
			cwdecoder.h
			$(CC) $(CFLAGS) -c -o $@ rcfile.c

extension.o:		extension.c					\
			types.h						\
			cwirc.h						\
			extension.h					\
			ipc.h						\
			common.h
			$(CC) $(CFLAGS) -c -o $@ extension.c

sounder_down.h:		sounder_down.wav				\
			mksndinclude
			./mksndinclude sounder_down > $@ < sounder_down.wav

sounder_up.h:		sounder_up.wav					\
			mksndinclude
			./mksndinclude sounder_up > $@ < sounder_up.wav

mksndinclude:		mksndinclude.c					\
			types.h
			$(CC) $(CFLAGS) -o $@ mksndinclude.c

common.h:
			echo "#define FRONTEND \"$(FRONTEND)\"" > $@
			echo "#define VERSION \"$(VERSION)\"" >> $@
			echo "#define EXTENSIONS_DIR			\
			\"$(CWIRC_EXTENSIONS_DIRECTORY)\"" >> $@

clean:
			$(RM) -f $(FRONTEND)
			$(RM) -f *.so
			$(RM) -f *.o
			$(RM) -f common.h
			$(RM) -f sounder_down.h
			$(RM) -f sounder_up.h
			$(RM) -f mksndinclude
			$(RM) -rf release

missing_settings:
			@(if [ ! "$(TARGET_OS)" ] ||			\
			     [ ! "$(PLUGIN_INSTALL_DIRECTORY)" ] ||	\
			     [ ! "$(FRONTEND_INSTALL_DIRECTORY)" ] ||	\
			     [ ! "$(CWIRC_EXTENSIONS_DIRECTORY)" ];then	\
			    echo;					\
			    echo "*** Please edit the Makefile to ***";	\
			    echo "**** set the target OS and the ****";	\
			    echo "**** CWirc installation paths. ****";	\
			    echo;					\
			    exit 1;					\
			  fi)

########## RELEASE ONLY SECTION ################################################
SRCFILES=	COPYING Changelog Makefile README LISEZMOI RELEASE_NOTES\
		schematics/rs232_key_connection.jpg			\
		schematics/cw_oscillator.jpg cwdecoder.c cwframe.c	\
		cwsound.c frontend.c extension.c grid.c gui.c keyer.c	\
		io.c ipc.c mksndinclude.c plugin.c propagation.c	\
		rcfile.c						\
		cwdecoder.h cwframe.h cwirc.h cwsound.h extension.h	\
		grid.h gui.h keyer.h io.h ipc.h morsecodes.h		\
		propagation.h rcfile.h types.h xchat/xchat-plugin.h	\
		xchat/README.xchat_include_file				\
		straightkey.xpm iambickey.xpm smeter.xpm sidetone.xpm	\
		sounder_down.wav sounder_up.wav				\
		debian/changelog debian/compat debian/control		\
		debian/copyright debian/rules debian/watch		\
		rpm/cwirc.spec rpm/rpmmacros

release:	source_release debian_release rpm_release

source_release:	release/cwirc-$(VERSION).tar.gz

release/cwirc-$(VERSION).tar.gz:
		$(MKDIR) -p release/cwirc-$(VERSION)
		$(CP) --parents -a $(SRCFILES) release/cwirc-$(VERSION)
		$(TAR) -C release -cvzf $@ cwirc-$(VERSION)
		$(RM) -r release/cwirc-$(VERSION)

debian_release: release/cwirc-$(VERSION).tar.gz
		$(MKDIR) -p release/debian
		$(TAR) -C release/debian -zxf $<
		(cd release/debian/cwirc-$(VERSION) &&			\
			dpkg-buildpackage -rfakeroot)
		$(RM) -rf release/debian/cwirc-$(VERSION)

rpm_release:	release/cwirc-$(VERSION).tar.gz
		$(MKDIR) -p release/rpm/RPM/BUILD
		$(MKDIR) -p release/rpm/RPM/RPMS
		$(MKDIR) -p release/rpm/RPM/SOURCES
		$(MKDIR) -p release/rpm/RPM/SPECS
		$(MKDIR) -p release/rpm/RPM/SRPMS
		(if [ -f ~/.rpmmacros ];then				\
		   $(CP) -a ~/.rpmmacros release/rpm/RPM;		\
		 fi)
		$(CP) rpm/rpmmacros ~/.rpmmacros
		(RPMTOPDIR=`cd release/rpm/RPM && $(PWD)`;		\
		 echo "%_topdir $$RPMTOPDIR" >> ~/.rpmmacros)
		$(CP) release/cwirc-$(VERSION).tar.gz release/rpm/RPM/SOURCES
		$(CP) rpm/cwirc.spec release/rpm/RPM/SPECS
		rpm -ba release/rpm/RPM/SPECS/cwirc.spec
		$(CP) release/rpm/RPM/RPMS/*/*.rpm release/rpm
		$(CP) release/rpm/RPM/SRPMS/*.src.rpm release/rpm
		$(RM) ~/.rpmmacros
		(if [ -f release/rpm/RPM/.rpmmacros ];then		\
		   $(CP) -a release/rpm/RPM/.rpmmacros ~;		\
		 fi)
		$(RM) -rf release/rpm/RPM
################################################################################

## cwirc 2.0.0

=== Makefile ===
--- 
+++ 
@@ -44,7 +44,7 @@
 
 ################################################################################
 
-VERSION=1.8.8
+VERSION=2.0.0
 
 PLUGIN=cwirc.so
 FRONTEND=cwirc_frontend

=== debian/changelog ===
cwirc (2.0.0-5) unstable; urgency=low

  * QA upload
    - Bump Standard-Version to 3.9.2
  * Patch 0000-fix-ftbfs-with-ld-as-needed.patch
    - Reorder libraries to fix FTBFS with ld --as-needed, thanks
      John Nogatch (Closes: 638633)

 -- Leo Iannacone <l3on@ubuntu.com>  Wed, 14 Dec 2011 15:10:35 +0100

cwirc (2.0.0-4) unstable; urgency=low

  * QA upload.
    - Update to packaging format "3.0 (quilt)".
  * debian/compat
    - Update to 8.
  * debian/control
    - (Build-Depends): Update to debhelper 8. From xchat-common remove *-1
      Debian revision.
    - (Depends): Add ${misc:Depends}.
    - (Homepage): New.
    - (Standards-Version): Update to 3.9.1.
  * debian/copyright
    - Point to GPL-2.
    - Update layout. Use FSF URL. Update download URL.
  * debian/{debian-lintian.mk,pod2man.mk}
    - New makefile snippets.
  * debian/{clean,dirs,manpages,cwirc.lintian-overrides}
    - New files.
  * debian/rules
    - Convert to dh(1).
  * debian/source/format
    - New file.
  * debian/watch
    - Update URL (Closes: #551346).

 -- Jari Aalto <jari.aalto@cante.net>  Sat, 30 Oct 2010 21:10:08 +0300

cwirc (2.0.0-3) unstable; urgency=low

  * Retiring - set the package maintainer to Debian QA Group.

 -- Joop Stakenborg <pa3aba@debian.org>  Fri, 30 Oct 2009 21:13:11 +0000

cwirc (2.0.0-2) unstable; urgency=low

  * Handle nostrip build options. Closes: #436689.

 -- Joop Stakenborg <pa3aba@debian.org>  Tue, 04 Dec 2007 10:39:31 +0100

cwirc (2.0.0-1) unstable; urgency=low

  * New upstream.

 -- Joop Stakenborg <pa3aba@debian.org>  Sun, 21 May 2006 22:31:46 +0200

cwirc (1.8.8-2) unstable; urgency=low

  * Add a watch file.

 -- Joop Stakenborg <pa3aba@debian.org>  Mon, 20 Feb 2006 17:46:19 +0100

cwirc (1.8.8-1) unstable; urgency=low

  * New upstream release

 -- Joop Stakenborg <pa3aba@debian.org>  Thu,  5 Aug 2004 21:23:48 +0200

cwirc (1.8.8-0) unstable; urgency=low
  * Corrected a bug in the incoming signal buffering that would overwrite
    buffered events when frames would come too fast during the fade-out period,
    just after a buffer underrun.

 -- Pierre-Philippe Coupard <pcoupard@easyconnect.fr>  Thu, 05 Aug 2004 01:27:00 +0200

cwirc (1.8.7-0) unstable; urgency=low
  * Added a section in the README to explain how to use CWirc with the aRts
    daemon. The DTR line is now explicitely set so that CWirc can read back
    the state of the Morse key contact(s), even if another program left the
    serial port in a bad state.

 -- Pierre-Philippe Coupard <pcoupard@easyconnect.fr>  Sun, 25 Jul 2004 18:30:00 +0200

cwirc (1.8.6-0) unstable; urgency=low
  * Made the plugin stub filter out CWirc frames even when the plugin is
    disabled, so it's now possible to close the CWirc panel and keep chatting
    normally on a Morse channel. Made the plugin stub correctly handle channel
    locks on different IRC servers, and made it warn the user when a lock is
    stale.

 -- Pierre-Philippe Coupard <pcoupard@easyconnect.fr>  Mon, 19 Jul 2004 02:52:00 +0200

cwirc (1.8.5-0) unstable; urgency=low
  * Corrected the README and added a French translation of it. Added the -fPIC
    flag to build the plugin's object files. Changed the Debian package
    maintainer and merged his changes.

 -- Pierre-Philippe Coupard <pcoupard@easyconnect.fr>  Thu, 08 Jul 2004 23:03:00 +0200

cwirc (1.8.4-1.0.0.1.pure64) unstable; urgency=low

  * Build extra shared objects with -fPIC for the plugin

 -- Goswin von Brederlow <brederlo@informatik.uni-tuebingen.de>  Thu,  8 Jul 2004 19:04:02 +0200

cwirc (1.8.4-1) unstable; urgency=low

  * Initial debian release.

 -- Joop Stakenborg <pa3aba@debian.org>  Sat,  3 Jul 2004 09:16:02 +0200

cwirc (1.8.4-0) unstable; urgency=low
  * Corrected a bug that would leave the I/O process running alone if the GUI
    quit without stopping it properly. Made the extension API's shared memory
    key really random. CWirc now tries to renice itself if the frontend binary
    is installed suid root, in order to get better I/O performances and cure
    the scratchy sound problem with low-end sound devices and loaded systems.

 -- Pierre-Philippe Coupard <pcoupard@easyconnect.fr>  Sun, 20 Jun 2004 19:03:00 +0200

cwirc (1.8.3-1) unstable; urgency=low
  * Made the sound fragment writing routine less fragile. Doubled the automatic
    decoder's speed indicator as a decoder reset button. Fixed a bug where the
    CWirc front-end would stop if X-Chat was started from an xterm and the
    terminal was resized.

 -- Pierre-Philippe Coupard <pcoupard@easyconnect.fr>  Fri, 18 Jun 2004 03:21:00 +0200

cwirc (1.8.2-1) unstable; urgency=low
  * Reduced the memory and disk footprint. General code cleanup. Made the keyer
    settings tab become inactive when the selected key type is "straight".
    Changed all references to "QRM" into the correct "QRN". Fixed a GTK error
    message when starting the GUI. Fixed a bug that could prevent an extension
    to be run again if it failed to run once.

 -- Pierre-Philippe Coupard <pcoupard@easyconnect.fr>  Sun, 13 Jun 2004 23:55:08 +0200

cwirc (1.8.1-1) unstable; urgency=low
  * Now the plugin doesn't report incoming morse from any source but the
    current IRC channel, on the current CWirc channel. Fixed a bug that would
    make CWirc occasionally send malformed frames containing null events when
    running with the CW output set to "sounder".

 -- Pierre-Philippe Coupard <pcoupard@easyconnect.fr>  Tue, 13 Apr 2004 01:50:08 +0200

cwirc (1.8.0-1) unstable; urgency=low
  * Re-implemented the keyer, with a full set of options. The frontend now
    checks its version number against the plugin's, to avoid using an
    incompatible shared memory structure.

 -- Pierre-Philippe Coupard <pcoupard@easyconnect.fr>  Thu, 01 Apr 2004 00:09:20 +0200

cwirc (1.7.7-1) unstable; urgency=low
  * Added "About" tab to give general information about CWirc. Made the cwirc
    window non-resizable. Added two new keyer modes besides mode-A and mode-B :


=== debian/control ===
Source: cwirc
Section: hamradio
Priority: optional
Maintainer: Debian QA Group <packages@qa.debian.org>
Build-Depends: debhelper (>= 8), libgtk2.0-dev, xchat-common (>= 2.0.2)
Standards-Version: 3.9.2
Homepage: http://myspace.voo.be/pcoupard/cwirc

Package: cwirc
Architecture: any
Depends: ${misc:Depends}, ${shlibs:Depends}, xchat (>= 2.0.2-1)
Description: X-Chat morse plugin
 CWirc is a plugin for the X-Chat IRC client to transmit raw morse code over
 the internet using IRC servers as reflectors. The transmitted morse code can
 be received in near real-time by other X-Chat clients with the CWirc plugin.
 CWirc tries to emulate a standard amateur radio rig : it sends and receives
 morse over virtual channels, and it can listen to multiple senders transmitting
 on the same channel. Morse code is keyed locally using a straight or iambic
 key connected to a serial port, or using the mouse buttons, and the sound is
 played through the soundcard.

=== debian/rules ===
#!/usr/bin/make -f

PACKAGE = cwirc
MANSECT = 1

include debian/pod2man.mk
include debian/debian-lintian.mk

ifeq (,$(findstring nostrip,$(DEB_BUILD_OPTIONS)))
	INSTALL_BIN =  install -s
else
	INSTALL_BIN = install
endif

man:
	$(MAKE) -C debian -f pod2man.mk PACKAGE=$(PACKAGE)_frontend \
	MANSECT=$(MANSECT) makeman

override_dh_auto_build: man
	$(MAKE) TARGET_OS=LINUX					\
		PLUGIN_INSTALL_DIRECTORY=dummy			\
		FRONTEND_INSTALL_DIRECTORY=dummy		\
		CWIRC_EXTENSIONS_DIRECTORY=/usr/lib/cwirc/extensions

override_dh_auto_install:
	$(lintian-overrides)
	$(INSTALL_BIN) cwirc.so debian/cwirc/usr/lib/xchat/plugins/cwirc.so
	$(INSTALL_BIN) cwirc_frontend debian/cwirc/usr/bin/cwirc_frontend

override_dh_installdocs:
	dh_installdocs README LISEZMOI schematics

override_dh_installchangelogs:
	dh_installchangelogs Changelog

%:
	dh $@

# End of file

=== debian/watch ===
version=3
http://myspace.voo.be/pcoupard/cwirc/ download/cwirc-(.*)\.tar\.gz
